#ifndef __MX6QMODAS_CONFIG_H
#define __MX6QMODAS_CONFIG_H

#define CONFIG_MACH_TYPE	            3980
#define CONFIG_MXC_UART_BASE	        UART1_BASE
#define CONFIG_CONSOLE_DEV		        "ttymxc0"
#define CONFIG_MMCROOT			          "/dev/mmcblk1p2"
#define CONFIG_DEFAULT_FDT_FILE	      "imx6q-modas.dtb"
#define PHYS_SDRAM_SIZE		            (1u * 128 * 1024 * 1024)

#define CONFIG_MX6
#define CONFIG_MX6Q

#include "mx6_common.h"

#include <asm/arch/imx-regs.h>

#define CONFIG_CMD_FUSE
#define CONFIG_MXC_OCOTP

#define CONFIG_HARD_I2C
#define CONFIG_I2C_MXC
#define CONFIG_SYS_I2C_BASE         I2C2_BASE_ADDR
#define CONFIG_SYS_I2C_CLK_OFFSET   I2C2_CLK_OFFSET
#define CONFIG_SYS_I2C_SPEED        100000
#define CONFIG_SYS_I2C_PMIC_PFUZE100_ADDR    (0x08)

#define CONFIG_CMDLINE_TAG
#define CONFIG_SETUP_MEMORY_TAGS
#define CONFIG_INITRD_TAG
#define CONFIG_REVISION_TAG

#define CONFIG_ENV_OFFSET         (6 * 64 * 1024)
#define CONFIG_ENV_SIZE (64*1024)
#if 0
#define CONFIG_ENV_IS_IN_SPI_FLASH
#define CONFIG_ENV_SECT_SIZE      CONFIG_ENV_SIZE
#else
#define CONFIG_ENV_IS_IN_MMC
#endif

/* Size of malloc() pool */
#define CONFIG_SYS_MALLOC_LEN   (CONFIG_ENV_SIZE + 2 * 1024 * 1024)

#define CONFIG_BOARD_EARLY_INIT_F
#define CONFIG_BOARD_LATE_INIT
#define CONFIG_MXC_GPIO
#define CONFIG_MXC_UART
#define CONFIG_HARD_SPI   1
#define CONFIG_MXC_SPI    1
#define CONFIG_DEFAULT_SPI_BUS  1
#define CONFIG_DEFAULT_SPI_MODE (SPI_MODE_0 | SPI_CS_HIGH)
#define CONFIG_CMD_SF

/* MMC Configs */
#define CONFIG_FSL_ESDHC
#define CONFIG_FSL_USDHC
#define CONFIG_SYS_FSL_ESDHC_ADDR      0

#define CONFIG_SPI_FLASH
#define CONFIG_SPI_FLASH_SST
#define CONFIG_SPI

#define CONFIG_MMC
#define CONFIG_CMD_MMC
#define CONFIG_GENERIC_MMC
#define CONFIG_BOUNCE_BUFFER
#define CONFIG_CMD_EXT2
#define CONFIG_CMD_FAT
#define CONFIG_DOS_PARTITION

#define CONFIG_CMD_PING
#define CONFIG_CMD_DHCP
#define CONFIG_CMD_MII
#define CONFIG_CMD_NET
#define CONFIG_FEC_MXC
#define CONFIG_MII
#define IMX_FEC_BASE            ENET_BASE_ADDR
#define CONFIG_FEC_XCV_TYPE     RGMII
#define CONFIG_ETHPRIME         "FEC"
#define CONFIG_FEC_MXC_PHYADDR  1
#define CONFIG_LAST_STAGE_INIT
#define CONFIG_UCP
#define CONFIG_UCP_UPG_ADDR     0x11000000

#define CONFIG_CMD_SDRAM
// #define CONFIG_CMD_UBI
// #define CONFIG_CMD_UBIFS
#define CONFIG_CMD_USB
#define CONFIG_USB_EHCI
#define CONFIG_USB_EHCI_MX6
#define CONFIG_USB_STORAGE
#define CONFIG_USB_HOST_ETHER
#define CONFIG_MXC_USB_PORT 1
#define CONFIG_MXC_USB_PORTSC (PORT_PTS_UTMI | PORT_PTS_PTW)
#define CONFIG_MXC_USB_FLAGS  0

#define CONFIG_PHYLIB
#define CONFIG_PHY_ATHEROS

/* allow to overwrite serial and ethaddr */
#define CONFIG_ENV_OVERWRITE
#define CONFIG_CONS_INDEX              1
#define CONFIG_BAUDRATE                115200

/* Command definition */
#include <config_cmd_default.h>

#define CONFIG_CMD_BMODE
#define CONFIG_CMD_BOOTZ
#define CONFIG_CMD_SETEXPR
#undef CONFIG_CMD_IMLS

#define CONFIG_BOOTDELAY               1

#define CONFIG_LOADADDR                0x12000000
#define CONFIG_SYS_TEXT_BASE           0x17800000

#define CONFIG_ARP_TIMEOUT     200UL

/* Miscellaneous configurable options */
#define CONFIG_SYS_LONGHELP
#define CONFIG_SYS_HUSH_PARSER
#define CONFIG_SYS_PROMPT_HUSH_PS2     "> "
#define CONFIG_AUTO_COMPLETE
#define CONFIG_SYS_CBSIZE              256

#define CONFIG_SYS_PROMPT              "Modas> "

/* Print Buffer Size */
#define CONFIG_SYS_PBSIZE              (CONFIG_SYS_CBSIZE + sizeof(CONFIG_SYS_PROMPT) + 16)
#define CONFIG_SYS_MAXARGS             16
#define CONFIG_SYS_BARGSIZE            CONFIG_SYS_CBSIZE

#define CONFIG_SYS_MEMTEST_START       0x10000000
#define CONFIG_SYS_MEMTEST_END         0x10010000
#define CONFIG_SYS_MEMTEST_SCRATCH     0x10800000

#define CONFIG_SYS_LOAD_ADDR           CONFIG_LOADADDR
#define CONFIG_SYS_HZ                  1000

#define CONFIG_CMDLINE_EDITING
#define CONFIG_STACKSIZE               (128 * 1024)

/* Physical Memory Map */
#define CONFIG_NR_DRAM_BANKS           1
#define PHYS_SDRAM                     MMDC0_ARB_BASE_ADDR

#define CONFIG_SYS_SDRAM_BASE          PHYS_SDRAM
#define CONFIG_SYS_INIT_RAM_ADDR       IRAM_BASE_ADDR
#define CONFIG_SYS_INIT_RAM_SIZE       IRAM_SIZE

#define CONFIG_SYS_INIT_SP_OFFSET \
  (CONFIG_SYS_INIT_RAM_SIZE - GENERATED_GBL_DATA_SIZE)
#define CONFIG_SYS_INIT_SP_ADDR \
  (CONFIG_SYS_INIT_RAM_ADDR + CONFIG_SYS_INIT_SP_OFFSET)

/* FLASH and environment organization */
#define CONFIG_SYS_NO_FLASH


#ifndef CONFIG_SYS_DCACHE_OFF
#define CONFIG_CMD_CACHE
#endif


#define CONFIG_OF_LIBFDT
#define CONFIG_FIT
#define CONFIG_MISC_INIT_R


#define CONFIG_SYS_FSL_USDHC_NUM	  3
#if defined(CONFIG_ENV_IS_IN_MMC)
#define CONFIG_SYS_MMC_ENV_DEV		  1	/* SDHC3 */
#endif


#define CONFIG_EXTRA_ENV_SETTINGS \
  "console=" CONFIG_CONSOLE_DEV "\0" \
  "mmcdev=" __stringify(CONFIG_SYS_MMC_ENV_DEV) "\0" \
  "mmcpart=1\0" \
  "bootdelay=0\0" \
  "ethprime=FEC\0" \
  "ipaddr=192.168.190.111\0" \
  "serverip=192.168.190.249\0" \
  "bootargs=console=" CONFIG_CONSOLE_DEV ",115200 /maxcpus=1\0" \
  ""

/*
setenv serverip 192.168.190.249
setenv ipaddr 192.168.190.111
setenv bootcmd tftp 0x12000000 uImage\; tftp 0x13000000 CpioRoot\; tftp 0x14000000 DTB\; bootm 0x12000000 0x13000000 0x14000000
saveenv
*/

/*
bootargs=console=ttymxc0,115200 maxcpus=1
bootcmd=tftp 0x12000000 uImage; tftp 0x13000000 CpioRoot; tftp 0x14000000 DTB; bootm 0x12000000 0x13000000 0x14000000
bootdelay=1
console=ttymxc0
ethact=FEC
ethaddr=90:5F:8D:00:00:00
ethprime=FEC
fileaddr=14000000
filesize=8d5c
ipaddr=192.168.190.111
loadaddr=0x12000000
mmcdev=1
mmcpart=1
mmcroot=/dev/mmcblk1p2 rootwait rw
serverip=192.168.190.249
*/

#define CONFIG_BOOTCOMMAND "tftp 0x12000000 uImage; tftp 0x13000000 CpioRoot; tftp 0x14000000 DTB; bootm 0x12000000 0x13000000 0x14000000"

#endif /* __MX6QMODAS_CONFIG_H */
