/*
 * Copyright (C) 2012 Freescale Semiconductor, Inc.
 *
 * Configuration settings for the Freescale i.MX6Q SabreSD board.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.         See the
 * GNU General Public License for more details.
 */

#ifndef __MX6QSABRESD_CONFIG_H
#define __MX6QSABRESD_CONFIG_H

#define CONFIG_MACH_TYPE	            3980
#define CONFIG_MXC_UART_BASE	        UART1_BASE
#define CONFIG_CONSOLE_DEV		        "ttymxc0"
#define CONFIG_MMCROOT			          "/dev/mmcblk1p2"
#define CONFIG_DEFAULT_FDT_FILE	      "imx6q-sabresd.dtb"
#define PHYS_SDRAM_SIZE		            (1u * 1024 * 1024 * 1024)

#include "mx6qsabre_common.h"

#define CONFIG_FIT
#define CONFIG_MISC_INIT_R

#undef CONFIG_SYS_PROMPT
#define CONFIG_SYS_PROMPT              "Modas> "

#define CONFIG_SYS_FSL_USDHC_NUM	  3
#if defined(CONFIG_ENV_IS_IN_MMC)
#define CONFIG_SYS_MMC_ENV_DEV		  1	/* SDHC3 */
#endif

#ifdef CONFIG_EXTRA_ENV_SETTINGS
#undef CONFIG_EXTRA_ENV_SETTINGS
#endif

#ifdef CONFIG_BOOTCOMMAND
#undef CONFIG_BOOTCOMMAND
#endif

#undef CONFIG_ENV_SIZE
#define CONFIG_ENV_SIZE (64*1024)

#define CONFIG_EXTRA_ENV_SETTINGS \
  "console=" CONFIG_CONSOLE_DEV "\0" \
  "mmcdev=" __stringify(CONFIG_SYS_MMC_ENV_DEV) "\0" \
  "mmcpart=1\0" \
  "bootdelay=0\0" \
  "bootargs=console=" CONFIG_CONSOLE_DEV ",115200 /dev/mmcblk1p2 rootwait rw\0" \
  "mmcroot=" CONFIG_MMCROOT " rootwait rw\0" \
  ""

#define CONFIG_BOOTCOMMAND "mmc dev 1; mmc read ${loadaddr} 0x800 0x1000; bootm ${loadaddr}"

#endif                         /* __MX6QSABRESD_CONFIG_H */
