#ifndef __MX6SMODAS_CONFIG_H
#define __MX6SMODAS_CONFIG_H

#define CONFIG_CONSOLE_DEV_INDEX      2

#ifdef CONFIG_BWLC
#ifdef CONFIG_CONSOLE_DEV_INDEX
#undef CONFIG_CONSOLE_DEV_INDEX
#endif
#define CONFIG_CONSOLE_DEV_INDEX  0
#endif

#define CONFIG_MACH_TYPE	            3980
#if 0
#define CONFIG_SILENT_CONSOLE       /* enable silent startup */
#define CONFIG_DISABLE_CONSOLE      /* disable console */
#define CONFIG_SYS_DEVICE_NULLDEV   /* include nulldev device */
#else
// MTODO Starting kernel... -> Reboot wenn wir UART3_BASE angeben
#define CONFIG_MXC_UART
#define CONFIG_MXC_UART_BASE	        UART1_BASE
#endif
#if CONFIG_CONSOLE_DEV_INDEX == 2
#define CONFIG_CONSOLE_DEV            "ttymxc2"
#endif
#if CONFIG_CONSOLE_DEV_INDEX == 0
#define CONFIG_CONSOLE_DEV            "ttymxc0"
#endif
#define CONFIG_MMCROOT			          "/dev/mmcblk1p2"
#define CONFIG_DEFAULT_FDT_FILE	      "imx6s-modas.dtb"
#define PHYS_SDRAM_SIZE		            (1u * 128 * 1024 * 1024)

#define CONFIG_MX6
#define CONFIG_MX6S

#include "mx6_common.h"

#include <asm/arch/imx-regs.h>

#define CONFIG_CMD_FUSE
#define CONFIG_MXC_OCOTP

#define CONFIG_HARD_I2C
#define CONFIG_I2C_MXC
#define CONFIG_SYS_I2C_BASE         I2C2_BASE_ADDR
#define CONFIG_SYS_I2C_CLK_OFFSET   I2C2_CLK_OFFSET
#define CONFIG_SYS_I2C_SPEED        100000
#define CONFIG_SYS_I2C_PMIC_PFUZE100_ADDR    (0x08)

#define CONFIG_HW_WATCHDOG
#define CONFIG_IMX_WATCHDOG
#define CONFIG_WATCHDOG_TIMEOUT_MSECS 8000

#define CONFIG_CMDLINE_TAG
#define CONFIG_SETUP_MEMORY_TAGS
#define CONFIG_INITRD_TAG
#define CONFIG_REVISION_TAG


/* Size of malloc() pool */
#define CONFIG_SYS_MALLOC_LEN   (CONFIG_ENV_SIZE + 2 * 1024 * 1024)

#define CONFIG_BOARD_EARLY_INIT_F
#define CONFIG_BOARD_LATE_INIT
#define CONFIG_MXC_GPIO

#define CONFIG_CMD_SPI
#define CONFIG_CMD_SF
#define CONFIG_CMD_FLASH

 #define CONFIG_FSL_SF  1

#define CONFIG_HARD_SPI   1
#define CONFIG_MXC_SPI

#define CONFIG_SPI
#define CONFIG_SPI_FLASH
#define CONFIG_SPI_FLASH_SST
#define CONFIG_SPI_FLASH_STMICRO
#define ENV_GPIO(port, index)       (((((port)-1)*32)+((index)&31)) << 8)
#define CONFIG_ENV_SPI_BUS          2
#define CONFIG_ENV_SPI_CS           (0|ENV_GPIO(4, 24))
#define CONFIG_ENV_SPI_MAX_HZ       10000000
#define CONFIG_ENV_SPI_MODE         (SPI_MODE_0)
#define CONFIG_ENV_OFFSET           (2 * 256 * 1024)
#define CONFIG_ENV_SIZE             (256*1024)

#define CONFIG_ENV_IS_IN_MMC
#define CONFIG_SYS_MMC_ENV_DEV      0

#define CONFIG_ENV_SECT_SIZE        (256*1024)
/* allow to overwrite serial and ethaddr */
#define CONFIG_ENV_OVERWRITE

#define CONFIG_SF_DEFAULT_BUS       CONFIG_ENV_SPI_BUS
#define CONFIG_SF_DEFAULT_CS       CONFIG_ENV_SPI_CS
#define CONFIG_SF_DEFAULT_SPEED       CONFIG_ENV_SPI_MAX_HZ
#define CONFIG_SF_DEFAULT_MODE       CONFIG_ENV_SPI_MODE

/* MMC Configs */
#define CONFIG_FSL_ESDHC
#define CONFIG_FSL_USDHC
#define CONFIG_SYS_FSL_ESDHC_ADDR      0
#define CONFIG_SYS_FSL_ESDHC_NUM        2

#define CONFIG_MMC
#define CONFIG_CMD_MMC
#define CONFIG_GENERIC_MMC
#define CONFIG_BOUNCE_BUFFER
#define CONFIG_CMD_EXT2
#define CONFIG_CMD_FAT
#define CONFIG_DOS_PARTITION

#define CONFIG_CMD_PING
#define CONFIG_CMD_DHCP
#define CONFIG_CMD_MII
#define CONFIG_CMD_NET
#define CONFIG_FEC_MXC
#define CONFIG_MII
#define IMX_FEC_BASE            ENET_BASE_ADDR
#define CONFIG_FEC_XCV_TYPE     RGMII
#define CONFIG_ETHPRIME         "FEC"

#define CONFIG_FEC_MXC_PHYADDR  4

// #define DISABLE_GBIT_ENET

#define CONFIG_CMD_SDRAM
#define CONFIG_CMD_USB

#define CONFIG_FS_EXT4
#define CONFIG_FS_FAT

#define CONFIG_USB_STORAGE
#define CONFIG_SUPPORT_VFAT
#define CONFIG_USB_EHCI
#define CONFIG_USB_EHCI_MX6
#define CONFIG_USB_STORAGE
#define CONFIG_MXC_USB_PORT 1
#define CONFIG_MXC_USB_PORTSC (PORT_PTS_UTMI | PORT_PTS_PTW)
#define CONFIG_MXC_USB_FLAGS  MXC_EHCI_POWER_PINS_ENABLED

#define BOOT_SETFUSES 1
#define BOOT_DEVICE_EMMC    1
//#define BOOT_DEVICE_SDCARD  1

#define DEFAULT_SUBNET "192.168.190."

#ifdef BOOT_DEVICE_SDCARD
#ifdef BOOT_DEVICE_EMMC
#error Only MMC OR SDCard
#endif
#endif

#define CONFIG_REPORT_STATE_FUNCTION ReportUBootState

#define CONFIG_PHYLIB

// #define CONFIG_PHY_ATHEROS

#define CONFIG_BAUDRATE                115200

/* Command definition */
#include <config_cmd_default.h>

#define CONFIG_CMD_BMODE
#define CONFIG_CMD_BOOTZ
#define CONFIG_CMD_SETEXPR
#undef CONFIG_CMD_IMLS

#define CONFIG_BOOTDELAY               1

#define CONFIG_LOADADDR                0x12000000
#define CONFIG_SYS_TEXT_BASE           0x17800000     // 0x17800000
#define CONFIG_SYS_MMC_MAX_BIT 4

#define CONFIG_ARP_TIMEOUT     200UL

/* Miscellaneous configurable options */
#define CONFIG_SYS_LONGHELP
#define CONFIG_SYS_HUSH_PARSER
#define CONFIG_SYS_PROMPT_HUSH_PS2     "> "
#define CONFIG_AUTO_COMPLETE
#define CONFIG_SYS_CBSIZE              256

#define CONFIG_SYS_PROMPT              "Modas> "

/* Print Buffer Size */
#define CONFIG_SYS_PBSIZE              (CONFIG_SYS_CBSIZE + sizeof(CONFIG_SYS_PROMPT) + 16)
#define CONFIG_SYS_MAXARGS             16
#define CONFIG_SYS_BARGSIZE            CONFIG_SYS_CBSIZE

#define CONFIG_SYS_MEMTEST_START       0x10000000
#define CONFIG_SYS_MEMTEST_END         0x10010000
#define CONFIG_SYS_MEMTEST_SCRATCH     0x10800000

#define CONFIG_SYS_LOAD_ADDR           CONFIG_LOADADDR
#define CONFIG_SYS_HZ                  1000

#define CONFIG_CMDLINE_EDITING
#define CONFIG_STACKSIZE               (128 * 1024)

/* Physical Memory Map */
#define CONFIG_NR_DRAM_BANKS           1
#define PHYS_SDRAM                     MMDC0_ARB_BASE_ADDR

#define CONFIG_SYS_SDRAM_BASE          PHYS_SDRAM
#define CONFIG_SYS_INIT_RAM_ADDR       IRAM_BASE_ADDR
#define CONFIG_SYS_INIT_RAM_SIZE       IRAM_SIZE

#define CONFIG_SYS_INIT_SP_OFFSET \
  (CONFIG_SYS_INIT_RAM_SIZE - GENERATED_GBL_DATA_SIZE)
#define CONFIG_SYS_INIT_SP_ADDR \
  (CONFIG_SYS_INIT_RAM_ADDR + CONFIG_SYS_INIT_SP_OFFSET)

/* FLASH and environment organization */
#define CONFIG_SYS_NO_FLASH

#ifndef CONFIG_SYS_DCACHE_OFF
#define CONFIG_CMD_CACHE
#endif

#define CONFIG_OF_LIBFDT
#define CONFIG_FIT
#define CONFIG_MISC_INIT_R

#define CONFIG_LAST_STAGE_INIT
#define CONFIG_UCP
#define CONFIG_UCP_UPG_ADDR     0x11000000

#define CONFIG_SYS_FSL_USDHC_NUM 1

#define CONFIG_EXTRA_ENV_SETTINGS \
  "console=" CONFIG_CONSOLE_DEV "\0" \
  "bootdelay=0\0" \
  "ethprime=FEC\0" \
  "ipaddr=192.168.190.111\0" \
  "ethaddr=00:11:22:00:00:00\0" \
  "serverip=192.168.190.249\0" \
  "BootMMC=mmc read 0x12000000 0x00000800 0x00004000; mmc read 0x13000000 0x00005000 0x00005000; mmc read 0x14000000 0x0000A000 0x00000200; bootm 0x12000000 0x13000000 0x14000000\0" \
  "BootTFTP=tftp 0x12000000 uImage; tftp 0x13000000 CpioRoot; tftp 0x14000000 DTB; bootm 0x12000000 0x13000000 0x14000000\0" \
  "bootargs=console=" CONFIG_CONSOLE_DEV ",115200 ath9k.ps_enable=1 pci=nomsi /maxcpus=1\0" \
  ""


#define CONFIG_BOOTCOMMAND "mmc read 0x12000000 0x00000800 0x00004000; mmc read 0x13000000 0x00005000 0x00005000; mmc read 0x14000000 0x0000A000 0x00000200; bootm 0x12000000 0x13000000 0x14000000"

#endif /* __MX6QMODAS_CONFIG_H */
