#ifndef __MX6QMODAS_CONFIG_H
#define __MX6QMODAS_CONFIG_H

#define CONFIG_MACH_TYPE	            3980
#define CONFIG_MXC_UART
#define CONFIG_MXC_UART_BASE	        UART1_BASE
#define CONFIG_CONSOLE_DEV		        "ttymxc0"
#define CONFIG_MMCROOT			          "/dev/mmcblk1p2"
#define CONFIG_DEFAULT_FDT_FILE	      "imx6s-modas.dtb"
#define PHYS_SDRAM_SIZE		            0

#define CONFIG_MX6

#include "mx6_common.h"

#include <asm/arch/imx-regs.h>

/* Size of malloc() pool */
#define CONFIG_SYS_MALLOC_LEN         (CONFIG_ENV_SIZE + 2 * 1024)

#define CONFIG_MXC_GPIO

#define CONFIG_BOARD_EARLY_INIT_F
#define CONFIG_BOARD_LATE_INIT

#define CONFIG_BAUDRATE                115200

#define CONFIG_ENV_IS_NOWHERE

#define CONFIG_SYS_TEXT_BASE           0x00908000

/* Miscellaneous configurable options */
#define CONFIG_SYS_PROMPT_HUSH_PS2     "> "
#define CONFIG_SYS_CBSIZE              256
#define CONFIG_SYS_PROMPT              "Modas> "

/* Print Buffer Size */
#define CONFIG_SYS_PBSIZE              (CONFIG_SYS_CBSIZE + sizeof(CONFIG_SYS_PROMPT) + 16)
#define CONFIG_SYS_MAXARGS             16
#define CONFIG_SYS_BARGSIZE            CONFIG_SYS_CBSIZE

#define CONFIG_SYS_HZ                  1000
#define CONFIG_STACKSIZE               (2 * 1024)

/* Physical Memory Map */
#define CONFIG_NR_DRAM_BANKS           1
#define PHYS_SDRAM                     MMDC0_ARB_BASE_ADDR

#define CONFIG_SYS_SDRAM_BASE          PHYS_SDRAM
#define CONFIG_SYS_INIT_RAM_ADDR       IRAM_BASE_ADDR
#define CONFIG_SYS_INIT_RAM_SIZE       IRAM_SIZE

#define CONFIG_SYS_INIT_SP_OFFSET \
  (CONFIG_SYS_INIT_RAM_SIZE - GENERATED_GBL_DATA_SIZE)
#define CONFIG_SYS_INIT_SP_ADDR \
  (CONFIG_SYS_INIT_RAM_ADDR + CONFIG_SYS_INIT_SP_OFFSET)

#define CONFIG_SYS_NO_FLASH

#define CONFIG_ENV_SIZE             (4*1024)

#if 0
#define CONFIG_OF_LIBFDT
#define CONFIG_FIT
#define CONFIG_MISC_INIT_R
#endif

#define CONFIG_SYS_LOAD_ADDR 0

#define CONFIG_EXTRA_ENV_SETTINGS \
  "console=" CONFIG_CONSOLE_DEV "\0" \
  "mmcdev=" __stringify(CONFIG_SYS_MMC_ENV_DEV) "\0" \
  "mmcpart=1\0" \
  "bootdelay=0\0" \
  "ethprime=FEC\0" \
  "ipaddr=192.168.190.111\0" \
  "serverip=192.168.190.249\0" \
  "bootargs=console=" CONFIG_CONSOLE_DEV ",115200 /maxcpus=1\0" \
  ""


#define CONFIG_BOOTCOMMAND "tftp 0x12000000 uImage; tftp 0x13000000 CpioRoot; tftp 0x14000000 DTB; bootm 0x12000000 0x13000000 0x14000000"

#endif /* __MX6QMODAS_CONFIG_H */
